function [vx,vy, gridx, gridy, energylist] = flowwithSIFT( im1, im2 )

    im1=im2double(im1);
    im2=im2double(im2);


    % Compute the dense SIFT image

    % patchsize is half of the window size for computing SIFT
    % gridspacing is the sampling precision

    patchsize=8;
    gridspacing=1;

    [Sift1, gridx, gridy] = dense_sift(im1,patchsize,gridspacing);
    gridy = gridy(:,1);
    gridx = gridx(1,:);
    Sift2 = dense_sift(im2,patchsize,gridspacing);

    % SIFT flow matching

    % prepare the parameters
    SIFTflowpara.alpha=2;
    SIFTflowpara.d=40;
    SIFTflowpara.gamma=0.005;
    SIFTflowpara.nlevels=4;
    SIFTflowpara.wsize=5;
    SIFTflowpara.topwsize=20;
    SIFTflowpara.nIterations=60;

    [vx,vy,energylist] = SIFTflowc2f( Sift1, Sift2, SIFTflowpara );

end