function new_energy = process_energy(energy, Im1, Im2, warpI2, siftpara, displaypara)
    % Apply a threshold on energy, as well as masking "white" points.
    assert(isequal(size(Im1), size(warpI2)), 'Im1 and warpI2 should have the same size');
    [SY, SX, ~] = size(Im1);
    assert(isequal(size(energy), [SY, SX, 3]));
    
    new_energy = energy;
    new_energy(:,:,2) = min(new_energy(:,:,2) ./ (siftpara.gamma * displaypara.norm_thresh^2), 1);
    
    mask1 = (Im1(:,:,1) == 1) & (Im1(:,:,2) == 1) & (Im1(:,:,3) == 1);
    mask2 = (warpI2(:,:,1) == 1) & (warpI2(:,:,2) == 1) & (warpI2(:,:,3) == 1);
    mask3 = (Im2(:,:,1) == 1) & (Im2(:,:,2) == 1) & (Im2(:,:,3) == 1);
    
    mask_f = mask1 | mask2 | mask3;
    mask_f = ~mask_f;
    new_energy = new_energy .* repmat(mask_f,[1,1,3]);
end