
images = {};
images_encodees = { {'data/occlusion/exp_filter/2_', 1} };

for i = 1:numel(images_encodees)
    pref = images_encodees{i}{1};
    for j = 1:images_encodees{i}{2}
        images = [images, ...
            {{sprintf('%s0.jpg', pref), sprintf('%s%d.jpg', pref, j)} } , ...
            ];
    end;
end;
n_images = numel(images);

para_list = {[8, 0.000005, 2, 2]
    };

for i = 1:n_images
    for j = 2:2
        im1=imread(images{i}{mod(j, 2) + 1});
        im2=imread(images{i}{2 - mod(j, 2)});
        fprintf('Im1 : %s , Im2 : %s\n', images{i}{mod(j, 2) + 1}, images{i}{2 - mod(j, 2)});
        im1=imresize(imfilter(im1,fspecial('gaussian',7,1.),'same','replicate'),[256, NaN],'bicubic');
        im2=imresize(imfilter(im2,fspecial('gaussian',7,1.),'same','replicate'),[256, NaN],'bicubic');
        
        im1=im2double(im1);
        im2=im2double(im2);
        
        % We add a frame to the two images (the same) in order to "glue" it
        % as well as the inside
        MARGIN = 20;
        fr = generate_frame(size(im1));
        im1 = add_frame(im1, fr);
        im2 = add_frame(im2, fr);
        
        
        for para = para_list
            patchsize = para{1}(1);
            gamma = para{1}(2);
            alpha = para{1}(3);
            d_para = para{1}(4);
            
            gridspacing=1;
            
            Sift1=dense_sift(im1,patchsize,gridspacing);
            Sift2=dense_sift(im2,patchsize,gridspacing);
            
            % Step 3. SIFT flow matching
            
            % prepare the parameters
            SIFTflowpara.alpha=alpha;
            SIFTflowpara.d=d_para*alpha;
            SIFTflowpara.gamma=gamma;
            SIFTflowpara.nlevels=4;
            SIFTflowpara.wsize=5;
            SIFTflowpara.topwsize=20;
            SIFTflowpara.nIterations=60;
            
            tic;[vx,vy,energylist]=SIFTflowc2f(Sift1,Sift2,SIFTflowpara);
            my_time = toc;
            
            % Step 4.  Visualize the matching results
            Im1=im1(patchsize/2:end-patchsize/2+1,patchsize/2:end-patchsize/2+1,:);
            Im2=im2(patchsize/2:end-patchsize/2+1,patchsize/2:end-patchsize/2+1,:);
            warpI2=warpImage(Im2,vx,vy);
            
            fig = figure;%('Visible', 'off');
            title(sprintf('Im1 : %s,\n Im2 : %s', images{i}{mod(j, 2) + 1}, images{i}{2 - mod(j, 2)}));
            
            subplot(2,4,1);
            image(Im1);
            title(sprintf('%s', images{i}{mod(j, 2) + 1}));
            axis equal;
            
            subplot(2,4,2);
            image(Im2);
            title(sprintf('%s', images{i}{2 - mod(j, 2)}));
            axis equal;
            
            subplot(2,4,5);
            image(warpI2);
            title(sprintf('Elapsed time : %.1f s', my_time));
            axis equal;
            %print(f_wi, '-r100', '-dpng', sprintf('Output_images/WI_%d.png', i*100 + j*10 + 1));
            
            
            
            DisplayPara.norm_thresh = 10;
            DisplayPara.occl_thresh = 0.8;
            DisplayPara.occl_frac = 0.4;
            
            energy = get_flow_local_energy(vx, vy, Sift1, Sift2, SIFTflowpara);
            energy = process_energy(energy, Im1, Im2, warpI2, SIFTflowpara, DisplayPara);
            
            subplot(2,4,6);
            
            f_gray = energy(:,:,2);
            map = colormap(jet(256)); % Get the current colormap
            f_rgb = label2rgb(round(f_gray * 256), map);
            
            
            f_back = image(Im2);
            hold on;
            f_heat = image(f_rgb);
            hold off;
            
            set(f_back, 'AlphaData', 1);
            set(f_heat, 'AlphaData', 0.5);
            axis equal;
            title('Energy 2');
            
            
            subplot(2,4,[3,4,7,8]);           
            
            Im2 = Im2(MARGIN+1:end-MARGIN, MARGIN+1:end-MARGIN, :);
            
            L = image_segmentation(Im2);
            occ_mask = occlusion_mask(L, energy(MARGIN+1:end-MARGIN,MARGIN+1:end-MARGIN,2), DisplayPara);
            
            
            f_back2 = image(Im2);
            hold on;
            
            gx = imfilter(double(L), [0,-1,1]);
            gy = imfilter(double(L), [0;-1;1]);
            S = (gx.^2 + gy.^2);
            f_front = imshow(S==0);
            
            
            mask_rgb = occ_mask;
            mask_rgb(:,:,2) = zeros(size(occ_mask));
            mask_rgb(:,:,3) = zeros(size(occ_mask));
            f_occl = image(mask_rgb);
            
            hold off;
            set(f_back2, 'AlphaData', 1);
            set(f_front, 'AlphaData', 0.3*(S>0));
            set(f_occl, 'AlphaData', 0.8*occ_mask);            
            axis equal;
            title('Occlusions');
            
            %print(fig, '-r400', '-dpng', sprintf('Output/Experience_25/Images/SIFT_%d_pat%d_gamma%.0e_a%.0e_d%d.png', i*10 + j*1, patchsize, gamma, alpha, d_para));
            
            %close all;
        end;
        
    end;
end;



